BOOTSEC=0x07c0
SYSSEC=0x1000

.code16
.text

.global start
start:
	ljmp	$BOOTSEC, $go
go:
	movw	%cs, %ax
	movw	%ax, %ds
	movw	%ax, %ss
	movw	%ax, %es
	movw	%ax, %fs
	movw	%ax, %gs
	movw	$400, %sp

#output string: Loading System
	movw	$17, %cx
	movw	$0x1005, %dx
	movw	$0x000c, %bx
	movw	$msg, %bp
	movw	$0x1301, ax
	int	$0x10

	or	%dl, %dl
	movb	$0x08, %ah
	int	$0x13
	xor	%ch, %ch
	movw	%cx, sectors

#initialise registers for int 0x13
	movw	$SYSSEC, %ax
	movw	%ax, %es
	xor	%si, %si
	movw	$0x02, %cx
	xor	%dx, %dx
	xor	%bx, %bx
loading:
	movw	$0x0211, %ax

	int	$0x13
	jc	retry
	xor	%si, %si

#loading sectors on other headers or cylinders
	#movw	%es, %ax
	#add	$0x20, %ax
	#movw	%ax, %es
	#inc	%cl
	#cmp	$18, %cl
	#jbe	loading
	#movb	$1, %cl
	#inc	%dh
	#cmp	$2, %dh
	#jb	loading
	#xor	%dh, %dh
	#inc	%ch
	#cmp	$10, %ch
	#jb	loading
#
#All done, output success info
	#movw	$BOOTSEC, %ax
	#movw	%ax, %es
	#movw	$7, %cx
	#movw	$0x1105, %dx
	#movw	$0x000c, %bx
	#movw	$ok_msg, %bp
	#movw	$0x1301, %ax
	#int	$0x10
	
	jmp	hlt
	ljmp	$SYSSEC, $0

#if something goes wrong with loading
#retry 5 times
retry:
	inc	%si
	cmp	$5, %si
	jae	error_loading
	xor	%al, %al
	xor	%dl, %dl
	int	$0x13
	jmp	loading

hlt:
	jmp	hlt

#if things just doesn't go well after
#repeated retry
error_loading:
	movw	$BOOTSEC, %ax
	movw	%ax, %es
	xor	%si, %si
	movw	$21, %cx
	movw	$0x1005, %dx
	movw	$0x000c, %bx
	movw	$err_msg, %bp
	movw	$0x1301, %ax
	int	$0x10
	jmp	hlt

msg:	
	.ascii	"Loading System..."
err_msg:
	.ascii	"Error Loading System!"
ok_msg:
	.ascii	"Done..."
sectors:
	.word	0xab
.org	510
	.word	0xaa55
